/**

	HTTP Response Observer.
	
	Allows you to reload a file and set the contentType.
	Simple one-shot operation...

*/
function MozileObserver()
{
	this.service = null;
	this.href = null;
	this.contentType = null;
}


MozileObserver.prototype.initialise = function( )
{
	this.service = null;
	this.href = null;
	this.contentType = null;
};

/**
This is special method that gets called when HTTP responses are being observed.
*/	
MozileObserver.prototype.observe = function (subject, topic, data)
{
	var httpChannel = subject.QueryInterface(Components.interfaces.nsIHttpChannel);
	var uri = httpChannel.URI;
	if ( uri.spec == this.href )
	{
	  httpChannel.contentType = this.contentType;
		this.service.removeObserver(this,"http-on-examine-response");
		this.initialise();
	}
};

MozileObserver.prototype.add = function()
{
	this.service = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
	this.service.addObserver(this,"http-on-examine-response",false);
};


MozileObserver.prototype.reload = function( location, contentType )
{
	try
	{
		this.contentType = contentType;
		this.href = location.href;
		this.add();
		location.reload(true);
		return true;
	}
	catch (e)
	{
		return e;
	}
};


var mozileHttpObserver = new MozileObserver(); 

